"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Disclaimer = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const react_3 = require("@strata-foundation/react");
const Disclaimer = () => {
    const { onClose } = (0, react_2.useDisclosure)();
    const [hasAcknowledged, setHasAcknowledged] = (0, react_3.useLocalStorage)("strataDisclaimerAcknowledged", false);
    const handleAcknowledge = () => {
        setHasAcknowledged(true);
    };
    return (react_1.default.createElement(react_2.Modal, { isOpen: !hasAcknowledged, onClose: onClose, size: "sm", isCentered: true },
        react_1.default.createElement(react_2.ModalOverlay, null),
        react_1.default.createElement(react_2.ModalContent, null,
            react_1.default.createElement(react_2.ModalBody, { pt: 4, color: (0, react_2.useColorModeValue)("black", "white") },
                react_1.default.createElement(react_2.Text, { fontWeight: "bold" }, "Disclaimer"),
                react_1.default.createElement(react_2.Text, { fontSize: "sm" }, "Please note that participating in any Strata Protocol launch is a high-risk activity. The tokens you may receive in exchange for contributing to a launch could go to zero. Strata Protocol is not liable for any losses incurred by using our platform."),
                react_1.default.createElement(react_2.Text, { fontSize: "sm", mt: 4 }, "Strata Protocol is open-source and self-service. As a result, the Strata team does not perform diligence on projects and bears no responsibility for the quality of projects that utilize the Strata Launchpad. Be careful and do your own research before participating in any Strata Protocol launch."),
                react_1.default.createElement(react_2.Flex, { justifyContent: "center" },
                    react_1.default.createElement(react_2.Button, { variant: "ghost", colorScheme: "primary", onClick: handleAcknowledge, _hover: { bgColor: "transparent" } }, "I Accept"))))));
};
exports.Disclaimer = Disclaimer;
//# sourceMappingURL=Disclaimer.js.map