"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DarkModeDisplay = void 0;
const DisburseFunds_1 = require("@/components/DisburseFunds");
const candy_machine_1 = require("@/components/lbc/mint/candy-machine");
const MintedNftNotification_1 = require("@/components/lbc/mint/MintedNftNotification");
const utils_1 = require("@/components/lbc/mint/utils");
const useIsBountyAdmin_1 = require("@/hooks/useIsBountyAdmin");
const react_1 = require("@chakra-ui/react");
const solana_gateway_react_1 = require("@civic/solana-gateway-react");
const anchor = __importStar(require("@project-serum/anchor"));
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const web3_js_1 = require("@solana/web3.js");
const react_2 = require("@strata-foundation/react");
const router_1 = require("next/router");
const react_3 = __importStar(require("react"));
const react_hot_toast_1 = __importDefault(require("react-hot-toast"));
const src_1 = require("../../../../src");
const DynamicPricingCandyMachine = (props) => {
    var _a, _b, _c, _d;
    const { connection } = (0, wallet_adapter_react_1.useConnection)();
    const { publicKey, connected, signTransaction } = (0, wallet_adapter_react_1.useWallet)();
    const cmState = (0, src_1.useCandyMachineInfo)(props.candyMachineId);
    const { candyMachine, isWhitelistUser, refreshCandyMachineState, isActive, isPresale, } = cmState;
    const mintKey = candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.state.tokenMint;
    const { info: tokenBonding, loading, error, } = (0, react_2.useTokenBondingFromMint)(mintKey);
    const { price } = (0, src_1.useLivePrice)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const { isAdmin } = (0, useIsBountyAdmin_1.useIsBountyAdmin)(publicKey || undefined, tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const onMint = (args) => __awaiter(void 0, void 0, void 0, function* () {
        var _e;
        try {
            (_e = document.getElementById("#identity")) === null || _e === void 0 ? void 0 : _e.click();
            if (connected && (candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.program) && publicKey) {
                const mint = yield (0, candy_machine_1.mintOneToken)(candyMachine, publicKey, args);
                react_hot_toast_1.default.custom((t) => (react_3.default.createElement(MintedNftNotification_1.MintedNftNotification, { mint: mint, onDismiss: () => react_hot_toast_1.default.dismiss(t.id) })), {
                    duration: Infinity,
                });
            }
        }
        catch (error) {
            let message = error.msg || error.toString() || "Minting failed! Please try again!";
            let heading = "Transaction Failed";
            if (!error.msg) {
                if (!error.message) {
                    message = "Transaction Timeout! Please try again.";
                }
                else if (error.message.indexOf("0x137") != -1) {
                    message = `SOLD OUT!`;
                }
                else if (error.message.indexOf("0x135") != -1) {
                    message = `Insufficient funds to mint. Please fund your wallet.`;
                }
            }
            else {
                if (error.code === 311) {
                    message = `SOLD OUT!`;
                    window.location.reload();
                }
                else if (error.code === 312) {
                    message = `Minting period hasn't started yet.`;
                }
                else if (error.code === 6005 || error.code === 6006) {
                    heading = "Transaction Cancelled";
                    message =
                        "The price moved unfavorably by more than the configured slippage. Change slippage by clicking Advanced Settings";
                }
                else {
                    message = error.toString();
                }
            }
            console.error(error);
            react_hot_toast_1.default.custom((t) => (react_3.default.createElement(react_2.Notification, { show: t.visible, type: "error", heading: heading, message: message, onDismiss: () => react_hot_toast_1.default.dismiss(t.id) })), {
                duration: 120 * 1000,
            });
            // updates the candy machine state to reflect the lastest
            // information on chain
            refreshCandyMachineState();
        }
    });
    (0, react_3.useEffect)(() => {
        refreshCandyMachineState();
    }, [publicKey, props.candyMachineId, connection, refreshCandyMachineState]);
    const selectedProps = {
        borderBottom: "3px solid #F07733",
    };
    return (react_3.default.createElement(react_1.Box, { color: (0, react_1.useColorModeValue)("black", "white"), w: "full", backgroundColor: "black.500", height: "100vh", overflow: "auto", paddingBottom: "200px" },
        react_3.default.createElement(react_1.Container, { mt: "35px", justifyItems: "stretch", maxW: "600px" },
            react_3.default.createElement(react_1.Tabs, { varaint: "unstyled", isLazy: true },
                react_3.default.createElement(react_1.TabList, { borderBottom: "none" },
                    react_3.default.createElement(react_1.Tab, { _selected: selectedProps, fontWeight: 600 }, "Mint"),
                    tokenBonding && (react_3.default.createElement(react_1.Tab, { _selected: selectedProps, fontWeight: 600 }, "Transactions"))),
                react_3.default.createElement(react_1.TabPanels, null,
                    react_3.default.createElement(react_1.TabPanel, { p: 0, pt: 4 },
                        react_3.default.createElement(src_1.LbcStatus, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey }),
                        react_3.default.createElement(react_1.Box, { zIndex: 1, shadow: "xl", rounded: "lg", p: "16px", pb: "29px", minH: "300px", bg: "black.300" },
                            isAdmin && tokenBonding && (react_3.default.createElement(react_1.Box, { p: 4, borderBottom: "3px solid", borderRadius: "lg", borderColor: "gray.300" },
                                react_3.default.createElement(react_1.Heading, { size: "md" }, "Disburse Funds"),
                                react_3.default.createElement(DisburseFunds_1.DisburseFunds, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey, includeRetrievalCurve: true }))),
                            connected && (react_3.default.createElement(react_3.default.Fragment, null,
                                (loading || !candyMachine) && (react_3.default.createElement(react_1.Center, null,
                                    react_3.default.createElement(react_1.Spinner, null))),
                                !(loading || !candyMachine) && (react_3.default.createElement(react_1.VStack, { align: "stretch", spacing: 8 },
                                    tokenBonding && (react_3.default.createElement(src_1.LbcInfo, { price: price, tokenBondingKey: tokenBonding.publicKey })),
                                    !tokenBonding && react_3.default.createElement(src_1.CandyMachineInfo, Object.assign({}, cmState)),
                                    (candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.state.isActive) &&
                                        (candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.state.gatekeeper) &&
                                        publicKey &&
                                        signTransaction ? (react_3.default.createElement(solana_gateway_react_1.GatewayProvider, { wallet: {
                                            publicKey: publicKey ||
                                                new web3_js_1.PublicKey(candy_machine_1.CANDY_MACHINE_PROGRAM),
                                            //@ts-ignore
                                            signTransaction: wallet.signTransaction,
                                        }, gatekeeperNetwork: (_b = (_a = candyMachine === null || candyMachine === void 0 ? void 0 : candyMachine.state) === null || _a === void 0 ? void 0 : _a.gatekeeper) === null || _b === void 0 ? void 0 : _b.gatekeeperNetwork, 
                                        // @ts-ignore
                                        clusterUrl: connection._rpcEndpoint, options: { autoShowModal: false } },
                                        react_3.default.createElement(src_1.MintButton, { price: price, onMint: onMint, tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey, isDisabled: !isActive && (!isPresale || !isWhitelistUser), disabledText: `Mint launches ${(_c = getCountdownDate(candyMachine)) === null || _c === void 0 ? void 0 : _c.toLocaleTimeString()}` }))) : (react_3.default.createElement(src_1.MintButton, { price: price, onMint: onMint, tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey, isDisabled: !isActive && (!isPresale || !isWhitelistUser), disabledText: candyMachine &&
                                            `Mint launches ${(_d = getCountdownDate(candyMachine)) === null || _d === void 0 ? void 0 : _d.toLocaleTimeString()}` })),
                                    react_3.default.createElement(src_1.Branding, null))))),
                            !connected && (react_3.default.createElement(react_1.Center, null,
                                react_3.default.createElement(src_1.WalletModalButton, null, "Connect Wallet"))))),
                    react_3.default.createElement(react_1.TabPanel, { p: 0, pt: 4 },
                        react_3.default.createElement(react_1.Box, { zIndex: 1, shadow: "xl", rounded: "lg", p: "16px", pb: "29px", minH: "300px", bg: "black.300" },
                            loading && (react_3.default.createElement(react_1.Center, null,
                                react_3.default.createElement(react_1.Spinner, null))),
                            !loading && tokenBonding && (react_3.default.createElement(react_1.VStack, { align: "stretch", spacing: 8 },
                                react_3.default.createElement(src_1.BondingPlot, { tokenBondingKey: tokenBonding.publicKey }),
                                react_3.default.createElement(src_1.TransactionHistory, { tokenBondingKey: tokenBonding.publicKey }))))))))));
};
const getCountdownDate = (candyMachine) => {
    var _a;
    if (candyMachine.state.isActive &&
        ((_a = candyMachine.state.endSettings) === null || _a === void 0 ? void 0 : _a.endSettingType.date)) {
        return (0, utils_1.toDate)(candyMachine.state.endSettings.number);
    }
    return (0, utils_1.toDate)(candyMachine.state.goLiveDate
        ? candyMachine.state.goLiveDate
        : candyMachine.state.isPresale
            ? new anchor.BN(new Date().getTime() / 1000)
            : undefined);
};
const DarkModeDisplay = (props) => {
    const router = (0, router_1.useRouter)();
    const { candyMachineId: candyMachineIdRaw } = router.query;
    const candyMachineId = (0, react_2.usePublicKey)(candyMachineIdRaw);
    return (react_3.default.createElement(react_1.DarkMode, null,
        react_3.default.createElement(Home, Object.assign({ candyMachineId: candyMachineId }, props))));
};
exports.DarkModeDisplay = DarkModeDisplay;
exports.default = exports.DarkModeDisplay;
//# sourceMappingURL=FullCandyMachine.js.map