"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLivePrice = void 0;
const react_1 = require("@strata-foundation/react");
const react_2 = require("react");
function useLivePrice(tokenBondingKey) {
    const { pricing, loading } = (0, react_1.useBondingPricing)(tokenBondingKey);
    const [currentPrice, setCurrentPrice] = (0, react_2.useState)();
    const unixTime = (0, react_1.useSolanaUnixTime)();
    (0, react_2.useEffect)(() => {
        if (pricing) {
            setCurrentPrice(pricing.current(pricing.hierarchy.tokenBonding.baseMint, unixTime));
        }
    }, [unixTime, pricing]);
    return {
        loading,
        price: currentPrice,
    };
}
exports.useLivePrice = useLivePrice;
//# sourceMappingURL=useLivePrice.js.map